Index: palm/trunk/SOURCE/land_surface_model_mod.f90
===================================================================
--- palm/trunk/SOURCE/land_surface_model_mod.f90	(revision 4440)
+++ palm/trunk/SOURCE/land_surface_model_mod.f90	(revision 4441)
@@ -20,5 +20,6 @@
 ! Current revisions:
 ! -----------------
-! 
+! Change order of dimension in surface arrays %frac, %emissivity and %albedo 
+! to allow for better vectorization in the radiation interactions.
 ! 
 ! Former revisions:
@@ -2502,27 +2503,27 @@
 !--    fraction.
 !--    Set default values at each surface element. 
-       ALLOCATE ( surf_lsm_h%albedo_type(0:2,1:surf_lsm_h%ns) )
-       ALLOCATE ( surf_lsm_h%emissivity(0:2,1:surf_lsm_h%ns) )
+       ALLOCATE ( surf_lsm_h%albedo_type(1:surf_lsm_h%ns,0:2) )
+       ALLOCATE ( surf_lsm_h%emissivity(1:surf_lsm_h%ns,0:2) )
 !
 !--    Initialize albedo type according to its default type, in order to set values
 !--    independent on default albedo_type in radiation model. 
-       surf_lsm_h%albedo_type(ind_veg_wall,:)  =                               &
+       surf_lsm_h%albedo_type(:,ind_veg_wall)  =                               &
                              INT( vegetation_pars(ind_v_at,vegetation_type) )
-       surf_lsm_h%albedo_type(ind_wat_win,:)   =                               &
+       surf_lsm_h%albedo_type(:,ind_wat_win)   =                               &
                              INT( water_pars(ind_w_at,water_type)           )
-       surf_lsm_h%albedo_type(ind_pav_green,:) =                               &
+       surf_lsm_h%albedo_type(:,ind_pav_green) =                               &
                              INT( pavement_pars(ind_p_at,pavement_type)     )
        surf_lsm_h%emissivity  = emissivity
        DO  l = 0, 3
-          ALLOCATE ( surf_lsm_v(l)%albedo_type(0:2,1:surf_lsm_v(l)%ns) )
-          ALLOCATE ( surf_lsm_v(l)%emissivity(0:2,1:surf_lsm_v(l)%ns)  )
+          ALLOCATE ( surf_lsm_v(l)%albedo_type(1:surf_lsm_v(l)%ns,0:2) )
+          ALLOCATE ( surf_lsm_v(l)%emissivity(1:surf_lsm_v(l)%ns,0:2)  )
 !
 !--       Initialize albedo type according to its default type, in order to 
 !--       set values independent on default albedo_type in radiation model. 
-          surf_lsm_v(l)%albedo_type(ind_veg_wall,:)  =                         &
+          surf_lsm_v(l)%albedo_type(:,ind_veg_wall)  =                         &
                              INT( vegetation_pars(ind_v_at,vegetation_type) )
-          surf_lsm_v(l)%albedo_type(ind_wat_win,:)   =                         &
+          surf_lsm_v(l)%albedo_type(:,ind_wat_win)   =                         &
                              INT( water_pars(ind_w_at,water_type)           )
-          surf_lsm_v(l)%albedo_type(ind_pav_green,:) =                         &
+          surf_lsm_v(l)%albedo_type(:,ind_pav_green) =                         &
                              INT( pavement_pars(ind_p_at,pavement_type)     )
           surf_lsm_v(l)%emissivity  = emissivity
@@ -2531,8 +2532,8 @@
 !--    Allocate arrays for relative surface fraction. 
 !--    0 - vegetation fraction, 2 - water fraction, 1 - pavement fraction
-       ALLOCATE( surf_lsm_h%frac(0:2,1:surf_lsm_h%ns) )
+       ALLOCATE( surf_lsm_h%frac(1:surf_lsm_h%ns,0:2) )
        surf_lsm_h%frac = 0.0_wp
        DO  l = 0, 3
-          ALLOCATE( surf_lsm_v(l)%frac(0:2,1:surf_lsm_v(l)%ns) )
+          ALLOCATE( surf_lsm_v(l)%frac(1:surf_lsm_v(l)%ns,0:2) )
           surf_lsm_v(l)%frac = 0.0_wp
        ENDDO
@@ -2588,8 +2589,8 @@
          
              surf_lsm_h%vegetation_surface = .TRUE.
-             surf_lsm_h%frac(ind_veg_wall,:) = 1.0_wp
+             surf_lsm_h%frac(:,ind_veg_wall) = 1.0_wp
              DO  l = 0, 3
                 surf_lsm_v(l)%vegetation_surface = .TRUE.
-                surf_lsm_v(l)%frac(ind_veg_wall,:) = 1.0_wp
+                surf_lsm_v(l)%frac(:,ind_veg_wall) = 1.0_wp
              ENDDO
    
@@ -2597,10 +2598,10 @@
              
              surf_lsm_h%water_surface = .TRUE.
-             surf_lsm_h%frac(ind_wat_win,:) = 1.0_wp
+             surf_lsm_h%frac(:,ind_wat_win) = 1.0_wp
 !
 !--          Note, vertical water surface does not really make sense.
              DO  l = 0, 3  
                 surf_lsm_v(l)%water_surface   = .TRUE.
-                surf_lsm_v(l)%frac(ind_wat_win,:) = 1.0_wp
+                surf_lsm_v(l)%frac(:,ind_wat_win) = 1.0_wp
              ENDDO
 
@@ -2608,8 +2609,8 @@
              
              surf_lsm_h%pavement_surface = .TRUE.
-                surf_lsm_h%frac(ind_pav_green,:) = 1.0_wp
+                surf_lsm_h%frac(:,ind_pav_green) = 1.0_wp
              DO  l = 0, 3
                 surf_lsm_v(l)%pavement_surface   = .TRUE.
-                surf_lsm_v(l)%frac(ind_pav_green,:) = 1.0_wp
+                surf_lsm_v(l)%frac(:,ind_pav_green) = 1.0_wp
              ENDDO
 
@@ -2745,15 +2746,15 @@
              IF ( surface_fraction_f%frac(ind_veg_wall,j,i) /=                 &
                   surface_fraction_f%fill )  THEN
-                surf_lsm_h%frac(ind_veg_wall,m)  =                             &
+                surf_lsm_h%frac(m,ind_veg_wall)  =                             &
                                     surface_fraction_f%frac(ind_veg_wall,j,i)
              ENDIF
              IF ( surface_fraction_f%frac(ind_pav_green,j,i) /=                &
                   surface_fraction_f%fill )  THEN
-                surf_lsm_h%frac(ind_pav_green,m) =                             &
+                surf_lsm_h%frac(m,ind_pav_green) =                             &
                                     surface_fraction_f%frac(ind_pav_green,j,i)
              ENDIF
              IF ( surface_fraction_f%frac(ind_wat_win,j,i) /=                  &
                   surface_fraction_f%fill )  THEN
-                surf_lsm_h%frac(ind_wat_win,m)   =                             &
+                surf_lsm_h%frac(m,ind_wat_win)   =                             &
                                     surface_fraction_f%frac(ind_wat_win,j,i)
              ENDIF
@@ -2761,5 +2762,5 @@
 !--          Check if sum of relative fractions is zero. This case, give an
 !--          error message.
-             IF ( SUM ( surf_lsm_h%frac(:,m) ) == 0.0_wp )  THEN
+             IF ( SUM ( surf_lsm_h%frac(m,:) ) == 0.0_wp )  THEN
                 WRITE( message_string, * )                                     &
                                  'surface fractions at grid point (j,i) = (',  &
@@ -2773,8 +2774,8 @@
 !--          fractions to one. Note, at the moment no tile approach is 
 !--          implemented, so that relative fractions are either 1 or zero.
-             IF ( SUM ( surf_lsm_h%frac(:,m) ) > 1.0_wp  .OR.                  &
-                  SUM ( surf_lsm_h%frac(:,m) ) < 1.0_wp  )  THEN
-                surf_lsm_h%frac(:,m) = surf_lsm_h%frac(:,m) /                  &
-                                       SUM ( surf_lsm_h%frac(:,m) )
+             IF ( SUM ( surf_lsm_h%frac(m,:) ) > 1.0_wp  .OR.                  &
+                  SUM ( surf_lsm_h%frac(m,:) ) < 1.0_wp  )  THEN
+                surf_lsm_h%frac(m,:) = surf_lsm_h%frac(m,:) /                  &
+                                       SUM ( surf_lsm_h%frac(m,:) )
 
              ENDIF
@@ -2791,15 +2792,15 @@
                 IF ( surface_fraction_f%frac(ind_veg_wall,j,i) /=              &
                      surface_fraction_f%fill )  THEN
-                   surf_lsm_v(l)%frac(ind_veg_wall,m)  =                       &
+                   surf_lsm_v(l)%frac(m,ind_veg_wall)  =                       &
                                     surface_fraction_f%frac(ind_veg_wall,j,i)
                 ENDIF
                 IF ( surface_fraction_f%frac(ind_pav_green,j,i) /=             &
                      surface_fraction_f%fill )  THEN
-                   surf_lsm_v(l)%frac(ind_pav_green,m)  =                      &
+                   surf_lsm_v(l)%frac(m,ind_pav_green)  =                      &
                                     surface_fraction_f%frac(ind_pav_green,j,i)
                 ENDIF
                 IF ( surface_fraction_f%frac(ind_wat_win,j,i) /=               &
                      surface_fraction_f%fill )  THEN
-                   surf_lsm_v(l)%frac(ind_wat_win,m)  =                        &
+                   surf_lsm_v(l)%frac(m,ind_wat_win)  =                        &
                                     surface_fraction_f%frac(ind_wat_win,j,i)
                 ENDIF
@@ -2807,5 +2808,5 @@
 !--             Check if sum of relative fractions is zero. This case, give an
 !--             error message.
-                IF ( SUM ( surf_lsm_v(l)%frac(:,m) ) == 0.0_wp )  THEN
+                IF ( SUM ( surf_lsm_v(l)%frac(m,:) ) == 0.0_wp )  THEN
                    WRITE( message_string, * )                                  &
                                  'surface fractions at grid point (j,i) = (',  &
@@ -2819,8 +2820,8 @@
 !--             fractions to one. Note, at the moment no tile approach is 
 !--             implemented, so that relative fractions are either 1 or zero.
-                IF ( SUM ( surf_lsm_v(l)%frac(:,m) ) > 1.0_wp  .OR.            &
-                     SUM ( surf_lsm_v(l)%frac(:,m) ) < 1.0_wp  )  THEN
-                   surf_lsm_v(l)%frac(:,m) = surf_lsm_v(l)%frac(:,m) /         &
-                                             SUM ( surf_lsm_v(l)%frac(:,m) )
+                IF ( SUM ( surf_lsm_v(l)%frac(m,:) ) > 1.0_wp  .OR.            &
+                     SUM ( surf_lsm_v(l)%frac(m,:) ) < 1.0_wp  )  THEN
+                   surf_lsm_v(l)%frac(m,:) = surf_lsm_v(l)%frac(m,:) /         &
+                                             SUM ( surf_lsm_v(l)%frac(m,:) )
 
                 ENDIF
@@ -2834,9 +2835,9 @@
 
              IF ( vegetation_type_f%var(j,i) /= vegetation_type_f%fill )       &        
-                surf_lsm_h%frac(ind_veg_wall,m)  = 1.0_wp
+                surf_lsm_h%frac(m,ind_veg_wall)  = 1.0_wp
              IF ( pavement_type_f%var(j,i)   /= pavement_type_f%fill   )       &        
-                surf_lsm_h%frac(ind_pav_green,m) = 1.0_wp 
+                surf_lsm_h%frac(m,ind_pav_green) = 1.0_wp 
              IF ( water_type_f%var(j,i)      /= water_type_f%fill      )       &        
-                surf_lsm_h%frac(ind_wat_win,m)   = 1.0_wp       
+                surf_lsm_h%frac(m,ind_wat_win)   = 1.0_wp       
           ENDDO
           DO  l = 0, 3
@@ -2848,9 +2849,9 @@
      
                 IF ( vegetation_type_f%var(j,i) /= vegetation_type_f%fill )    &        
-                   surf_lsm_v(l)%frac(ind_veg_wall,m)  = 1.0_wp
+                   surf_lsm_v(l)%frac(m,ind_veg_wall)  = 1.0_wp
                 IF ( pavement_type_f%var(j,i)   /= pavement_type_f%fill   )    &        
-                   surf_lsm_v(l)%frac(ind_pav_green,m) = 1.0_wp 
+                   surf_lsm_v(l)%frac(m,ind_pav_green) = 1.0_wp 
                 IF ( water_type_f%var(j,i)      /= water_type_f%fill      )    &        
-                   surf_lsm_v(l)%frac(ind_wat_win,m)   = 1.0_wp     
+                   surf_lsm_v(l)%frac(m,ind_wat_win)   = 1.0_wp     
              ENDDO
           ENDDO
@@ -3218,6 +3219,6 @@
              surf_lsm_h%f_sw_in(m)          = f_shortwave_incoming
              surf_lsm_h%c_surface(m)        = c_surface
-             surf_lsm_h%albedo_type(ind_veg_wall,m) = albedo_type
-             surf_lsm_h%emissivity(ind_veg_wall,m)  = emissivity
+             surf_lsm_h%albedo_type(m,ind_veg_wall) = albedo_type
+             surf_lsm_h%emissivity(m,ind_veg_wall)  = emissivity
              
              surf_lsm_h%vegetation_type(m)      = vegetation_type
@@ -3247,6 +3248,6 @@
                 surf_lsm_v(l)%f_sw_in(m)          = f_shortwave_incoming
                 surf_lsm_v(l)%c_surface(m)        = c_surface
-                surf_lsm_v(l)%albedo_type(ind_veg_wall,m) = albedo_type
-                surf_lsm_v(l)%emissivity(ind_veg_wall,m)  = emissivity
+                surf_lsm_v(l)%albedo_type(m,ind_veg_wall) = albedo_type
+                surf_lsm_v(l)%emissivity(m,ind_veg_wall)  = emissivity
                 
                 surf_lsm_v(l)%vegetation_type(m)      = vegetation_type
@@ -3285,6 +3286,6 @@
                 surf_lsm_h%f_sw_in(m)          = vegetation_pars(ind_v_f_sw_in,st)
                 surf_lsm_h%c_surface(m)        = vegetation_pars(ind_v_c_surf,st)
-                surf_lsm_h%albedo_type(ind_veg_wall,m) = INT( vegetation_pars(ind_v_at,st) )
-                surf_lsm_h%emissivity(ind_veg_wall,m)  = vegetation_pars(ind_v_emis,st)
+                surf_lsm_h%albedo_type(m,ind_veg_wall) = INT( vegetation_pars(ind_v_at,st) )
+                surf_lsm_h%emissivity(m,ind_veg_wall)  = vegetation_pars(ind_v_emis,st)
                 
                 surf_lsm_h%vegetation_type(m)      = st
@@ -3314,6 +3315,6 @@
                    surf_lsm_v(l)%f_sw_in(m)          = vegetation_pars(ind_v_f_sw_in,st)
                    surf_lsm_v(l)%c_surface(m)        = vegetation_pars(ind_v_c_surf,st)
-                   surf_lsm_v(l)%albedo_type(ind_veg_wall,m) = INT( vegetation_pars(ind_v_at,st) )
-                   surf_lsm_v(l)%emissivity(ind_veg_wall,m)  = vegetation_pars(ind_v_emis,st)
+                   surf_lsm_v(l)%albedo_type(m,ind_veg_wall) = INT( vegetation_pars(ind_v_at,st) )
+                   surf_lsm_v(l)%emissivity(m,ind_veg_wall)  = vegetation_pars(ind_v_emis,st)
                    
                    surf_lsm_v(l)%vegetation_type(m)      = st
@@ -3393,9 +3394,9 @@
                 IF ( vegetation_pars_f%pars_xy(ind_v_at,j,i) /=                &
                      vegetation_pars_f%fill )                                  &
-                   surf_lsm_h%albedo_type(ind_veg_wall,m) =                    &
+                   surf_lsm_h%albedo_type(m,ind_veg_wall) =                    &
                                    INT( vegetation_pars_f%pars_xy(ind_v_at,j,i) )
                 IF ( vegetation_pars_f%pars_xy(ind_v_emis,j,i) /=              &
                      vegetation_pars_f%fill )                                  &
-                   surf_lsm_h%emissivity(ind_veg_wall,m)  =                    &
+                   surf_lsm_h%emissivity(m,ind_veg_wall)  =                    &
                                    vegetation_pars_f%pars_xy(ind_v_emis,j,i)
              ENDIF
@@ -3469,9 +3470,9 @@
                    IF ( vegetation_pars_f%pars_xy(ind_v_at,j,i) /=             &
                         vegetation_pars_f%fill )                               &
-                      surf_lsm_v(l)%albedo_type(ind_veg_wall,m) =              &
+                      surf_lsm_v(l)%albedo_type(m,ind_veg_wall) =              &
                                    INT( vegetation_pars_f%pars_xy(ind_v_at,j,i) )
                    IF ( vegetation_pars_f%pars_xy(ind_v_emis,j,i) /=           &
                         vegetation_pars_f%fill )                               &
-                      surf_lsm_v(l)%emissivity(ind_veg_wall,m)  =              &
+                      surf_lsm_v(l)%emissivity(m,ind_veg_wall)  =              &
                                    vegetation_pars_f%pars_xy(ind_v_emis,j,i)
                 ENDIF
@@ -3523,6 +3524,6 @@
              surf_lsm_h%lambda_surface_u(m) = 1.0E10_wp               
              surf_lsm_h%c_surface(m)        = 0.0_wp
-             surf_lsm_h%albedo_type(ind_wat_win,m) = albedo_type
-             surf_lsm_h%emissivity(ind_wat_win,m)  = emissivity
+             surf_lsm_h%albedo_type(m,ind_wat_win) = albedo_type
+             surf_lsm_h%emissivity(m,ind_wat_win)  = emissivity
              
              surf_lsm_h%water_type(m)      = water_type
@@ -3544,6 +3545,6 @@
                 surf_lsm_v(l)%lambda_surface_u(m) = 1.0E10_wp               
                 surf_lsm_v(l)%c_surface(m)        = 0.0_wp
-                surf_lsm_v(l)%albedo_type(ind_wat_win,m) = albedo_type
-                surf_lsm_v(l)%emissivity(ind_wat_win,m)  = emissivity
+                surf_lsm_v(l)%albedo_type(m,ind_wat_win) = albedo_type
+                surf_lsm_v(l)%emissivity(m,ind_wat_win)  = emissivity
                 
                 surf_lsm_v(l)%water_type(m)      = water_type
@@ -3577,6 +3578,6 @@
                 surf_lsm_h%lambda_surface_u(m) = water_pars(ind_w_lambda_u,st)              
                 surf_lsm_h%c_surface(m)        = 0.0_wp
-                surf_lsm_h%albedo_type(ind_wat_win,m) = INT( water_pars(ind_w_at,st) )
-                surf_lsm_h%emissivity(ind_wat_win,m)  = water_pars(ind_w_emis,st)
+                surf_lsm_h%albedo_type(m,ind_wat_win) = INT( water_pars(ind_w_at,st) )
+                surf_lsm_h%emissivity(m,ind_wat_win)  = water_pars(ind_w_emis,st)
                 
                 surf_lsm_h%water_type(m)      = st
@@ -3605,7 +3606,7 @@
                                                    water_pars(ind_w_lambda_u,st)           
                    surf_lsm_v(l)%c_surface(m)     = 0.0_wp
-                   surf_lsm_v(l)%albedo_type(ind_wat_win,m) =                  &
+                   surf_lsm_v(l)%albedo_type(m,ind_wat_win) =                  &
                                                   INT( water_pars(ind_w_at,st) )
-                   surf_lsm_v(l)%emissivity(ind_wat_win,m)  =                  &
+                   surf_lsm_v(l)%emissivity(m,ind_wat_win)  =                  &
                                                   water_pars(ind_w_emis,st)
                                                   
@@ -3664,10 +3665,10 @@
                 IF ( water_pars_f%pars_xy(ind_w_at,j,i) /=                     &
                      water_pars_f%fill )                                       &
-                   surf_lsm_h%albedo_type(ind_wat_win,m) =                     &
+                   surf_lsm_h%albedo_type(m,ind_wat_win) =                     &
                                        INT( water_pars_f%pars_xy(ind_w_at,j,i) )
 
                 IF ( water_pars_f%pars_xy(ind_w_emis,j,i) /=                   &
                      water_pars_f%fill )                                       &
-                   surf_lsm_h%emissivity(ind_wat_win,m) =                      &
+                   surf_lsm_h%emissivity(m,ind_wat_win) =                      &
                                           water_pars_f%pars_xy(ind_w_emis,j,i)  
              ENDIF
@@ -3724,10 +3725,10 @@
                    IF ( water_pars_f%pars_xy(ind_w_at,j,i) /=                  &
                         water_pars_f%fill )                                    &
-                      surf_lsm_v(l)%albedo_type(ind_wat_win,m) =               &
+                      surf_lsm_v(l)%albedo_type(m,ind_wat_win) =               &
                                       INT( water_pars_f%pars_xy(ind_w_at,j,i) )
 
                    IF ( water_pars_f%pars_xy(ind_w_emis,j,i) /=                &
                         water_pars_f%fill )                                    &
-                      surf_lsm_v(l)%emissivity(ind_wat_win,m)  =               &
+                      surf_lsm_v(l)%emissivity(m,ind_wat_win)  =               &
                                       water_pars_f%pars_xy(ind_w_emis,j,i)  
                 ENDIF
@@ -3810,6 +3811,6 @@
                                                         * 0.25_wp                                   
 
-             surf_lsm_h%albedo_type(ind_pav_green,m) = albedo_type
-             surf_lsm_h%emissivity(ind_pav_green,m)  = emissivity      
+             surf_lsm_h%albedo_type(m,ind_pav_green) = albedo_type
+             surf_lsm_h%emissivity(m,ind_pav_green)  = emissivity      
              
              surf_lsm_h%pavement_type(m)      = pavement_type
@@ -3848,6 +3849,6 @@
                                                         * 0.25_wp                                      
 
-                surf_lsm_v(l)%albedo_type(ind_pav_green,m) = albedo_type
-                surf_lsm_v(l)%emissivity(ind_pav_green,m)  = emissivity
+                surf_lsm_v(l)%albedo_type(m,ind_pav_green) = albedo_type
+                surf_lsm_v(l)%emissivity(m,ind_pav_green)  = emissivity
                 
                 surf_lsm_v(l)%pavement_type(m)      = pavement_type
@@ -3908,6 +3909,6 @@
                                                         * dz_soil(nzb_soil)    &
                                                         * 0.25_wp                               
-                surf_lsm_h%albedo_type(ind_pav_green,m) = INT( pavement_pars(ind_p_at,st) )
-                surf_lsm_h%emissivity(ind_pav_green,m)  = pavement_pars(ind_p_emis,st)  
+                surf_lsm_h%albedo_type(m,ind_pav_green) = INT( pavement_pars(ind_p_at,st) )
+                surf_lsm_h%emissivity(m,ind_pav_green)  = pavement_pars(ind_p_emis,st)  
                 
                 surf_lsm_h%pavement_type(m)      = st
@@ -3961,7 +3962,7 @@
                                                         * dz_soil(nzb_soil)    &
                                                         * 0.25_wp                                    
-                   surf_lsm_v(l)%albedo_type(ind_pav_green,m) =                &
+                   surf_lsm_v(l)%albedo_type(m,ind_pav_green) =                &
                                               INT( pavement_pars(ind_p_at,st) )
-                   surf_lsm_v(l)%emissivity(ind_pav_green,m)  =                &
+                   surf_lsm_v(l)%emissivity(m,ind_pav_green)  =                &
                                               pavement_pars(ind_p_emis,st)  
                                               
@@ -4030,9 +4031,9 @@
                 IF ( pavement_pars_f%pars_xy(ind_p_at,j,i) /=                  &
                      pavement_pars_f%fill )                                    &
-                   surf_lsm_h%albedo_type(ind_pav_green,m) =                   &
+                   surf_lsm_h%albedo_type(m,ind_pav_green) =                   &
                                    INT( pavement_pars_f%pars_xy(ind_p_at,j,i) )
                 IF ( pavement_pars_f%pars_xy(ind_p_emis,j,i) /=                &
                      pavement_pars_f%fill )                                    &
-                   surf_lsm_h%emissivity(ind_pav_green,m)  =                   &
+                   surf_lsm_h%emissivity(m,ind_pav_green)  =                   &
                                    pavement_pars_f%pars_xy(ind_p_emis,j,i)
              ENDIF 
@@ -4090,10 +4091,10 @@
                    IF ( pavement_pars_f%pars_xy(ind_p_at,j,i) /=               &
                         pavement_pars_f%fill )                                 &
-                      surf_lsm_v(l)%albedo_type(ind_pav_green,m) =             &
+                      surf_lsm_v(l)%albedo_type(m,ind_pav_green) =             &
                                    INT( pavement_pars_f%pars_xy(ind_p_at,j,i) )
 
                    IF ( pavement_pars_f%pars_xy(ind_p_emis,j,i) /=             &
                         pavement_pars_f%fill )                                 &
-                      surf_lsm_v(l)%emissivity(ind_pav_green,m)  =             &
+                      surf_lsm_v(l)%emissivity(m,ind_pav_green)  =             &
                                    pavement_pars_f%pars_xy(ind_p_emis,j,i)  
                 ENDIF 
